<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>LibGirl Monitor</title>
  <link crossorigin="anonymous" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
    integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" rel="stylesheet">
  <link rel="stylesheet"
    href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.standalone.css"
    integrity="sha256-9eB9aJkdMOPCUi0CBHbl6FWi/lIkXb+1oKi9bWFZ3HQ=" crossorigin="anonymous" />
</head>

<body>
  <article class="container">
    <div class="row">
      <div class="col-sm-12">
        <div class="card align-items-center">
          <h5>更新時間</h5>
          <p class="card-text"><label id="update_at">0</label></p>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">使用者總數</h5>
            <p class="card-text">
              <h5 id="user_count">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">總 Session 數</h5>
            <p class="card-text">
              <h5 id="session_count">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">總 Switch Turn 數</h5>
            <p class="card-text">
              <h5 id="switch_turn_count">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">平均每人 Switch Turn 數</h5>
            <p class="card-text">
              <h5 id="average_switch_turn">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">單輪遊人數</h5>
            <p class="card-text">
              <h5 id="once_user_count">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">非單輪遊人數</h5>
            <p class="card-text">
              <h5 id="multiple_user_count">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">非單輪遊 switch turn 數</h5>
            <p class="card-text">
              <h5 id="multiple_user_turn">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-12 row">
        <div class="col-sm-6">
          <p class="h4 text-center">連結點擊數</p>
          <table class="table table-hover table-striped table-sm" id="redirect_url_table">
          </table>
        </div>
        <div class="col-sm-6">
          <p class="h4 text-center">折價卷兌換數</p>
          <table class="table table-hover table-striped table-sm" id="redeemed_coupon_table">
          </table>
        </div>
      </div>
      <div class="col-sm-12">
        <canvas id="userSwitchTurnChart"></canvas>
      </div>
      <div class="col-sm-6">
        <canvas id="dailySwitchTurnChart"></canvas>
      </div>
      <div class="col-sm-6">
        <canvas id="dailyUserChart"></canvas>
      </div>
      <div class="col-sm-6">
        <canvas id="dailyNewUserChart"></canvas>
      </div>
      <div class="col-sm-6">
        <canvas id="dailyUserDurationChart"></canvas>
      </div>
      <div class="col-sm-12">
        <p class="h4 text-center">Weekly Retention</p>
        <table class="table table-hover table-striped" id="retention_table">
        </table>
      </div>
      <div class="col-sm-12">
        <p class="h4 text-center">Daily Retention</p>
        <table class="table table-hover table-striped table-sm" id="daily_retention_table">
        </table>
      </div>
      <div class="col-sm-12 row">
        <div class="col-sm-12">
          <p class="h4 text-center">折價卷被兌換數</p>
        </div>
        <div class="col-sm-4">
          <label>Coupon Event:</label>
          <select id="coupon_event"></select>
        </div>
        <div class="col-sm-4">
          <label>Start:</label>
          <input id="coupon_start" data-provide="datepicker">
        </div>
        <div class="col-sm-4">
          <label>End:</label>
          <input id="coupon_end" data-provide="datepicker">
        </div>
        <div class="col-sm-12">
          <button class="btn btn-outline-secondary" id="coupon_query_all_date">全部</button>
          <button class="btn btn-outline-secondary" id="coupon_query_this_week">本週</button>
          <button class="btn btn-primary" id="coupon_query_submit">Search</button>
        </div>
      </div>
      <div class="col-sm-3">
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">已兌換數量</h5>
            <p class="card-text">
              <h5 id="coupon_redeem_count">0</h5>
            </p>
          </div>
        </div>
      </div>
      <div class="col-sm-9">
        <canvas id="daily_coupon_redeem"></canvas>
      </div>
    </div>
  </article>
</body>
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/chart.js@2.8.0"></script>
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
  integrity="sha256-pasqAKBDmFT4eHoN2ndd6lN370kFiGUFyTiUHWhU7k8=" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
<script>
  const userSwitchTurnCtx = document.querySelector('#userSwitchTurnChart').getContext('2d');
  const dailySwitchTurnCtx = document.querySelector('#dailySwitchTurnChart').getContext('2d');
  const dailyUserCtx = document.querySelector('#dailyUserChart').getContext('2d');
  const retentionTable = document.querySelector('#retention_table');
  const dailyNewUserCtx = document.querySelector('#dailyNewUserChart').getContext('2d');
  const dailyRetentionTable = document.querySelector('#daily_retention_table');
  const dailyUserDurationCtx = document.querySelector('#dailyUserDurationChart').getContext('2d');
  const couponQuerySubmitBtn = document.querySelector('#coupon_query_submit');
  const dailyCouponRedeemCtx = document.querySelector('#daily_coupon_redeem').getContext('2d');
  const couponEventSelector = document.querySelector('#coupon_event');
  const redirectUrlTable = document.querySelector('#redirect_url_table');
  const redeemedCouponTable = document.querySelector('#redeemed_coupon_table');
  const couponStartInput = document.querySelector('#coupon_start');
  const couponEndInput = document.querySelector('#coupon_end');
  const couponQueryAllDateBtn = document.querySelector('#coupon_query_all_date');
  const couponQueryWeekBtn = document.querySelector('#coupon_query_this_week');

  const weekInterval = 7 * 24 * 60 * 60 * 1000;
  const dayInterval = 24 * 60 * 60 * 1000;
  const start = new Date('2019-11-28 10:00:00z').getTime();
  const apiUrl = 'https://qxi7wjof68.execute-api.us-east-1.amazonaws.com/production/libgirl/summary';
  let redirectUrls;
  let couponEventList;

  function createChart(ctx, type, labels, labelName, data) {
    return new Chart(ctx, {
      type: type,
      data: {
        labels: labels,
        datasets: [
          {
            label: labelName,
            backgroundColor: 'rgb(84,116,255)',
            borderColor: 'rgb(255,40,49)',
            data: data,
          },
        ],
      },
      options: {
        scales: {
          yAxes: [
            {
              ticks: {
                beginAtZero: true,
              },
            },
          ],
        },
      },
    });
  }

  const userSwitchTurnChart = createChart(userSwitchTurnCtx, 'bar', [], '使用者 Switch Turn 數分佈', []);
  const dailySwitchTurnChart = createChart(dailySwitchTurnCtx, 'bar', [], '每日平均每人 Switch Turn 數分佈', []);
  const dailyUserChart = createChart(dailyUserCtx, 'bar', [], 'Daily active users', []);
  const dailyNewUserChart = createChart(dailyNewUserCtx, 'bar', [], 'Daily new users', []);
  const dailyUserDurationChart = createChart(dailyUserDurationCtx, 'bar', [], '平均使用者停留時間（秒）', []);
  const dailyCouponRedeemChart = createChart(dailyCouponRedeemCtx, 'bar', [], '折價卷被兌換數', []);

  function updateUserSwitchTurnChart(switchTurnUserMap) {
    const { labels, values } = Object.entries(switchTurnUserMap).reduce((prev, [key, value]) => ({
      labels: [...prev.labels, key],
      values: [...prev.values, value],
    }), { labels: [], values: [] });

    userSwitchTurnChart.data.labels = labels;
    userSwitchTurnChart.data.datasets[0].data = values;
    userSwitchTurnChart.update();
  }

  function updateDailySwitchTurnChart(dateSwitchTurnMap) {
    const { labels, values } = Object.entries(dateSwitchTurnMap)
      .sort(([date1], [date2]) => new Date(date1) - new Date(date2))
      .reduce((prev, [key, value]) => ({
        labels: [...prev.labels, key],
        values: [...prev.values, value.turnCount / value.userCount],
      }), { labels: [], values: [] });

    dailySwitchTurnChart.data.labels = labels;
    dailySwitchTurnChart.data.datasets[0].data = values;
    dailySwitchTurnChart.update();
  }

  function updateDailyUserChart(dateMap) {
    const { labels, values } = Object.entries(dateMap)
      .sort(([date1], [date2]) => new Date(date1) - new Date(date2))
      .reduce((prev, [key, value]) => ({
        labels: [...prev.labels, key],
        values: [...prev.values, value.userCount],
      }), { labels: [], values: [] });

    dailyUserChart.data.labels = labels;
    dailyUserChart.data.datasets[0].data = values;
    dailyUserChart.update();
  }

  function updateDailyDurationChart(dateMap) {
    const { labels, values } = Object.entries(dateMap)
      .sort(([date1], [date2]) => new Date(date1) - new Date(date2))
      .reduce((prev, [key, value]) => ({
        labels: [...prev.labels, key],
        values: [...prev.values, value.avgDuration / 1000],
      }), { labels: [], values: [] });

    dailyUserDurationChart.data.labels = labels;
    dailyUserDurationChart.data.datasets[0].data = values;
    dailyUserDurationChart.update();
  }

  function updateDailyCouponRedeemChart(dateMap, start, end) {
    const daysCount = Math.ceil((end - start) / dayInterval);
    const labels = new Array(daysCount).fill(0);
    const values = new Array(daysCount).fill(0);

    for (let i = 0; i < daysCount; i++) {
      const date = new Date(start + i * dayInterval);
      labels[i] = `${date.getMonth() + 1}/${date.getDate()}/${date.getFullYear()}`;
      if (dateMap.hasOwnProperty(i)) {
        values[i] = dateMap[i];
      }
    }

    dailyCouponRedeemChart.data.labels = labels;
    dailyCouponRedeemChart.data.datasets[0].data = values;
    dailyCouponRedeemChart.update();
  }

  function getNumbers(i, number, total) {
    if (i === 0) {
      return { number, percentage: null };
    }
    return { number, percentage: total ? Math.round(number / total * 100 * 100) / 100 : 0 };
  }

  function retentionCellText(number, percentage) {
    if (percentage === null) {
      return number;
    }
    return `${number}\n${percentage}%`;
  }

  function updateRetention(retention) {
    retentionTable.innerHTML = '';
    const header = retentionTable.insertRow();
    header.insertCell().innerText = '新使用者來的日期 \\ 週留存率';
    header.insertCell().innerText = '人數';
    for (let i = 1; i < retention.length; i++) {
      const row = header.insertCell();
      row.innerText = `${i} 週`;
    }

    let weekStart = start;
    for (let index in retention) {
      const weeks = retention[index];
      const row = retentionTable.insertRow();
      row.insertCell().innerText = `Week ${parseInt(index) + 1} (${new Date(weekStart).toDateString()})`;
      const total = weeks[0];
      for (let i = 0; i < weeks.length; i++) {
        const cell = row.insertCell();
        if (isRetentionOver(i, weeks, index)) {
          const { number, percentage } = getNumbers(i, weeks[i], total);
          cell.innerText = retentionCellText(number, percentage);
          if (percentage >= 6) {
            cell.classList.add('table-success');
          } else if (percentage >= 4) {
            cell.classList.add('table-warning');
          } else if (percentage > 0) {
            cell.classList.add('table-secondary');
          }
        }
      }
      weekStart += weekInterval;
    }
  }

  function isRetentionOver(i, weeks, index) {
    return i < (weeks.length - index);
  }

  function weekDay(date) {
    const days = ['Sun', 'Mon', 'Tues', 'Wed', 'Thurs', 'Fri', 'Sat'];
    return days[date.getDay()];
  }

  function updateDailyRetention(retention) {
    dailyRetentionTable.innerHTML = '';
    const header = dailyRetentionTable.insertRow();
    header.insertCell();
    header.insertCell().innerText = '人數';
    for (let i = 1; i < retention.length; i++) {
      const row = header.insertCell();
      row.innerText = `${i} 天`;
    }

    let dayStart = start;
    for (let index in retention) {
      const days = retention[index];
      const row = dailyRetentionTable.insertRow();
      const date = new Date(dayStart);
      row.insertCell().innerText = `${date.getMonth() + 1}/${date.getDate()}\n${(weekDay(date))}`;
      const total = days[0];
      for (let i = 0; i < days.length; i++) {
        const cell = row.insertCell();
        if (isRetentionOver(i, days, index)) {
          const { number, percentage } = getNumbers(i, days[i], total);
          cell.innerText = retentionCellText(number, percentage);
          if (percentage >= 6) {
            cell.classList.add('table-success');
          } else if (percentage >= 4) {
            cell.classList.add('table-warning');
          } else if (percentage > 0) {
            cell.classList.add('table-secondary');
          }
        }
      }
      dayStart += dayInterval;
    }
  }

  function updateDailyNewUserChart(dailyNewUserMap) {
    const { labels, values } = Object.entries(dailyNewUserMap)
      .sort(([date1], [date2]) => new Date(date1) - new Date(date2))
      .reduce((prev, [key, value]) => ({
        labels: [...prev.labels, key],
        values: [...prev.values, value],
      }), { labels: [], values: [] });

    dailyNewUserChart.data.labels = labels;
    dailyNewUserChart.data.datasets[0].data = values;
    dailyNewUserChart.update();
  }

  function updateDashboard() {
    updateRedirectUrls();
    updateRedeemedCoupon();

    axios.get(apiUrl, {
      params: {
        action: 'query_sessions',
      },
    })
      .then((response) => {
        const { userCount, sessionCount, switchTurnCount, switchTurnUserMap, dailyData, retention, dailyNewUserMap, dailyRetention, updateAt } = response.data.data;
        document.querySelector('#update_at').textContent = new Date(updateAt);
        document.querySelector('#user_count').textContent = userCount;
        document.querySelector('#session_count').textContent = sessionCount;
        document.querySelector('#switch_turn_count').textContent = switchTurnCount;
        document.querySelector('#average_switch_turn').textContent = switchTurnCount / userCount;
        const onceUserCount = switchTurnUserMap[0] + switchTurnUserMap[1];
        document.querySelector('#once_user_count').textContent = onceUserCount;
        const multipleUserCount = userCount - onceUserCount;
        document.querySelector('#multiple_user_count').textContent = multipleUserCount;
        document.querySelector('#multiple_user_turn').textContent = (switchTurnCount - switchTurnUserMap[1]) / multipleUserCount;

        updateUserSwitchTurnChart(switchTurnUserMap);
        updateDailySwitchTurnChart(dailyData);
        updateDailyUserChart(dailyData);
        updateRetention(retention);
        updateDailyNewUserChart(dailyNewUserMap);
        updateDailyRetention(dailyRetention);
        updateDailyDurationChart(dailyData);
      }).catch(apiErrorHandler);
  }

  function apiErrorHandler(e) {
    console.error(e);
    alert('出錯啦');
  }

  function updateCouponEventList() {
    return axios.get(apiUrl, { params: { action: 'list_coupon_event' } }).then((res) => {
      couponEventList = res.data.data;
      couponEventList.forEach(e => {
        const option = document.createElement('option');
        option.text = e.title;
        option.value = e.event;
        couponEventSelector.appendChild(option);
      });
    }).catch(apiErrorHandler);
  }

  function updateRedirectUrls() {
    return axios.get(apiUrl, {
      params: {
        action: 'count_urls_clicks',
      },
    })
      .then((response) => {
        const { data } = response.data;
        redirectUrlTable.innerHTML = '';
        const header = redirectUrlTable.insertRow();
        header.insertCell().innerText = '標題';
        header.insertCell().innerText = '點擊數';

        data.forEach((each) => {
          const row = redirectUrlTable.insertRow();
          // url.event(recmd.json) <-> each.id(redirect-url-repository.ts - countUrl() )
          row.insertCell().innerText = redirectUrls.find(url => url.event === each.id).title;
          row.insertCell().innerText = each.count;
        });
      }).catch(apiErrorHandler);
  }

  function updateRedeemedCoupon() {
    axios.get(apiUrl, {
      params: {
        action: 'count_redeemed',
      },
    })
      .then((response) => {
        const { data } = response.data;
        redeemedCouponTable.innerHTML = '';
        const header = redeemedCouponTable.insertRow();
        header.insertCell().innerText = '標題';
        header.insertCell().innerText = '兌換數';

        data.forEach((each) => {
          const row = redeemedCouponTable.insertRow();
          row.insertCell().innerText = couponEventList.find(url => url.event === each.event).title;
          row.insertCell().innerText = each.count;
        });
      }).catch(apiErrorHandler);
  }

  function getRedirectUrls() {
    axios.get(apiUrl, {
      params: {
        action: 'list_redirect_urls',
      },
    }).then((response) => {
      redirectUrls = response.data.data;
    }).catch(apiErrorHandler);
  }

  function setDefaultCouponQueryDate() {
    couponStartInput.value = moment().startOf('week').format('MM/DD/YYYY');
    couponEndInput.value = moment().endOf('week').format('MM/DD/YYYY');
  }

  couponQuerySubmitBtn.addEventListener('click', (e) => {
    e.preventDefault();
    const event = couponEventSelector.value;
    const startDate = couponStartInput.value;
    const endDate = couponEndInput.value;
    const start = (new Date(startDate)).getTime();
    const end = (new Date(endDate)).getTime() + dayInterval - 1;
    axios.get(apiUrl, {
      params: {
        action: 'query_coupon',
        event, start, end,
      },
    }).then((res) => {
      const { daily, count } = res.data.data;
      document.querySelector('#coupon_redeem_count').innerText = count;
      updateDailyCouponRedeemChart(daily, start, end);
    }).catch(apiErrorHandler);
  });

  couponQueryAllDateBtn.addEventListener('click', (e) => {
    e.preventDefault();
    const selectedEvent = couponEventSelector.value;
    const event = couponEventList.find((c) => c.event === selectedEvent);
    couponStartInput.value = moment(event.start).format('MM/DD/YYYY');
    couponEndInput.value = moment(event.end).format('MM/DD/YYYY');
  });

  couponQueryWeekBtn.addEventListener('click', (e) => {
    e.preventDefault();
    setDefaultCouponQueryDate();
  });

  Promise.all([getRedirectUrls(), updateCouponEventList()]).then(() => {
    updateDashboard();
  });

  setDefaultCouponQueryDate();
  setInterval(updateDashboard, 10 * 60 * 1000);
</script>

</html>